
Synnefo - Feature # 177

Status: Closed Priority: High

Author: Vangelis Koukis Category: Cyclades API

Created: 01/25/2011 Assignee: Markos Gogoulos

Updated: 03/22/2011 Due date:

Subject: Κλήση του RS API για VM management

Description

Καθώς προχωράει η υλοποίηση του RS API, το UI πρέπει να ενημερωθεί ώστε να το χρησιμοποιεί και να γίνουν λειτουργικά όλα τα

τμήματά του.

Ενδεικτικά:

Το μολύβι στο όνομα του host κάνει PUT /servers/id.

Οι επιλογές shutdown/reboot/create/destroy κάνουν POST/DELETE στο /servers, κλπ

Related issues:

related to Synnefo - Feature # 293: Partial refresh στο GUI Closed 03/16/2011 04/01/2011

related to Synnefo - Feature # 307: Μολύβι για αλλαγή ονόματος Closed 03/22/2011 04/08/2011

related to Synnefo - Bug # 241: Το GUI περνάει λάθος imageId Closed 03/03/2011

related to Synnefo - Bug # 203: Ενημέρωση του χρήστη έπειτα από δημιουργία ει... Closed 02/01/2011 03/25/2011

History

#1 - 01/30/2011 09:36 pm - Markos Gogoulos

εχει αρχισει να γινεται. Για την ωρα στο list view παιζουν τα delete/reboot/shutdown machine, με ενα foo server_id (1234). Μενει να ρυθμιστει να

παιρνει το id του καθε machine.

#2 - 02/07/2011 06:14 pm - Markos Gogoulos

- Status changed from Assigned to Feedback

εχει γινει

#3 - 02/11/2011 12:07 pm - Constantinos Venetsanopoulos

- Status changed from Feedback to Assigned

Πρέπει να γίνει πλήρως λειτουργικό το UI κάνοντας όλες τις κλήσεις στο RS API και το μολύβι να κάνει PUT ώστε να αλλάξει το όνομα του

μηχανήματος

#4 - 03/06/2011 08:48 pm - Dimitris Moraitis

- Status changed from Assigned to Feedback

Το μολύβι πως ακριβώς θα πρέπει να δουλεύει; Θα βγαίνει inline text input και κουμπάκι/εικόνα για αποθήκευση από δίπλα; Ή θα βγαίνει φόρμα μέσα

σε overlay; Στην δεύτερη περίπτωση θα μπορούσε να αλλάζει και το description το οποίο έχει μπει στο μοντέλο και στο api αλλά δεν ορίζεται με

κάποιο τρόπο από το UI μέχρι στιγμής.
#5 - 03/09/2011 04:09 pm - Constantinos Venetsanopoulos

- Category set to Cyclades API

Το destroy server στο list view δεν παίζει. Κάποιες φορές γυρίζει error, κάποιες φορές γυρνάει successful submission αλλά δεν κάνει τπτ από πίσω.

Για το μολύβι θα γίνει update σύντομα

#6 - 03/09/2011 05:06 pm - Markos Gogoulos

είχε αλλάξει το URL του delete action και δεν δούλευε. Τώρα πρέπει να είναι οκ

#7 - 03/10/2011 10:39 am - Constantinos Venetsanopoulos

Τώρα όντως κάνει remove το μηχάνημα αλλά και πάλι πετάει error στο GUI.

Kαι στο server:

[10/Mar/2011 02:35:10] "DELETE /api/v1.0/servers/2 HTTP/1.1" 202 0

ERROR:synnefo.api.handlers:Unexpected error: 'DESTROY'

Traceback (most recent call last):

  File "/home/cven/synnefo/../synnefo/api/handlers.py", line 286, in delete

    vm.start_action('DESTROY')

  File "/home/cven/synnefo/../synnefo/db/models.py", line 424, in start_action

    raise VirtualMachine.InvalidActionError(action)

InvalidActionError: 'DESTROY'

[10/Mar/2011 02:35:10] "DELETE /api/v1.0/servers/2 HTTP/1.1" 503 124

#8 - 03/10/2011 02:01 pm - Constantinos Venetsanopoulos

- Status changed from Feedback to Assigned

#9 - 03/10/2011 02:03 pm - Markos Gogoulos

σε καθαρό περιβάλλον δοκιμάζω να σβήσω τα fixtures και δουλεύει κανονικά (κάνω delete σε 3 μηχανήματα μαζί)

Το output που γράφεις δεν θα έπρεπε να ισχύει (InvalidActionError: 'DESTROY') μιας και η destroy είναι valid action (:))

#10 - 03/10/2011 02:22 pm - Constantinos Venetsanopoulos

2 θέματα:

1. Σε καθαρό περιβάλλον δίνω destroy. Βλέπω από τον ganeti-0mqd ότι το μηχάνημα γίνεται remove κανονικά. Το GUI όμως μου βγάζει "error και

administrator notification". Μόλις κλείσω το overlay κάνει refresh και το μηχάνημα δεν υπάρχει πια (όπως σωστά συμβαίνει). Δεν ξέρω γιατι βγάζει

αυτό το μήνυμα το GUI. Ο server δεν έβγαλε αυτό το λάθος ξανά (τελευταίο git pull).

2. Έκανα create ένα μηχάνημα το οποίο σωστά ήρθε σε κατάσταση error (αυτό επέστρεψε το ganeti). Από τη στιγμή που είναι σε error state δεν μπορώ

να το κάνω destroy γιατί η επιλογή destroy δεν ανάβει στο list view. Αυτό αν νομίζεις ότι είναι ticket του GUI (που αυτό είναι το λογικό) άνοιξέ το

ξεχωριστά εκεί.
#11 - 03/15/2011 09:09 pm - Markos Gogoulos

εδώ εξακολουθούν να ισχύουν τα προβλήματα?

#12 - 03/17/2011 03:55 pm - Constantinos Venetsanopoulos

Υπάρχει θέμα με το destroy ακόμα. Τα κάνει destroy αλλά βλέπω πάλι errors και στο GUI και στο server:

ERROR:synnefo.api.handlers:Unexpected error: 'DESTROY'

Traceback (most recent call last):

  File "/home/cven/synnefo/../synnefo/api/handlers.py", line 294, in delete

    vm.start_action('DESTROY')

  File "/home/cven/synnefo/../synnefo/db/models.py", line 424, in start_action

    raise VirtualMachine.InvalidActionError(action)

InvalidActionError: 'DESTROY'

[17/Mar/2011 08:51:16] "DELETE /api/v1.0/servers/12 HTTP/1.1" 503 124

ERROR:synnefo.api.handlers:Unexpected error: 'DESTROY'

Traceback (most recent call last):

  File "/home/cven/synnefo/../synnefo/api/handlers.py", line 294, in delete

    vm.start_action('DESTROY')

  File "/home/cven/synnefo/../synnefo/db/models.py", line 424, in start_action

    raise VirtualMachine.InvalidActionError(action)

InvalidActionError: 'DESTROY'

[17/Mar/2011 08:51:16] "DELETE /api/v1.0/servers/12 HTTP/1.1" 503 124

#13 - 03/17/2011 08:30 pm - Markos Gogoulos

Η def delete (api/handlers.py 294 γραμμή) πριν εκτελέσει το action DELETE καλεί την start_action του vm:

vm.start_action('DESTROY')

η start_action (db/models.py 424 γραμμή) έχει το ακόλουθο:

if self.deleted:

    raise VirtualMachine.InvalidActionError(action)

τα vms που δείχνει η λίστα (και μπορείς να κάνεις destroy) είναι αυτά που έχουν το attribute deleted=False . Με βάση αυτά δεν θα έπρεπε να παίρνεις

το λάθος αυτό! Μόνη περίπτωση να στέλνει το action destroy 2 φορές και γι'αυτό την δεύτερη να φτάνει μέχρι το if self.deleted και να σου

επιστρέφει το exception. Φυσικά αυτό δεν θα έπρεπε να συμβαίνει

#14 - 03/18/2011 02:10 am - Dimitris Moraitis

- Status changed from Assigned to Feedback

διορθώθηκε στο commit:1a49199e5d5339c6b0154b38556ccdc012355939

#15 - 03/22/2011 10:59 am - Vangelis Koukis
Το DESTROY παίζει, άλλα έχει προβλήματα με το refresh στο list view. Κάνω destroy και το μηχάνημα μένει για πάντα στο list view.

Το μηχάνημα μένει για πάντα εκεί. Επίσης πρέπει να προχωρήσει το θέμα της ανανέωσης του ονόματος του server που εκκρεμμεί εδώ.

#16 - 03/22/2011 11:00 am - Vangelis Koukis

- Status changed from Feedback to Assigned

#17 - 03/22/2011 12:39 pm - Constantinos Venetsanopoulos

Η λειτουργικότητα μολυβιού και μετονομασίας VM συνεχίζεται στο #307 και μόνο εκεί.

Αυτό το ticket παραμένει ανοιχτό λόγω των παραπάνω παρατηρήσεων του Vangeli

#18 - 03/22/2011 01:27 pm - Vangelis Koukis

- Status changed from Assigned to Closed

Το πρόβλημα με το destroy οφείλεται στο [ήδη ανοιχτό] issue του partial refresh με Opera.

Οι λεπτομέρειες είναι στο #293 που εκκρεμεί.

Το συγκεκριμένο ticket το κλείνω, το GUI εκτελεί γενικά κλήσεις στο RS API, δεν υπάρχει λόγος να μένει ανοιχτό.

Η παρακολούθηση των bugs και features που αναφέρθηκαν εδώ συνεχίζεται στα #293, #307.
